<template>
  <!-- 财务报表 -->
  <div class="table-detail-container table-height"
       :loading="loading">
    <Filter @update="search"></Filter>
    <a-table :columns="columns"
             class="topOrderTable"
             :pagination="false"
             :expandedRowKeys="expandedRowKeys"
             :customRow="Rowclick"
             rowKey="key"
             :data-source="tableList"
             :scroll="{ x: '100%', y: 'calc(100vh - 163px)' }">
    </a-table>
    <!-- 明细 -->
    <Description v-if="visible"
                 @close="closeDrawer"
                 @changeTab="changeTab"
                 :tabList="tabList">
      <a-table :columns="columnsDetail"
               class="topTable"
               :pagination="false"
               rowKey="key"
               :data-source="detailTableList"
               :scroll="{ x: '100%', y: 'calc(100vh - 163px)' }">
      </a-table>
    </Description>
  </div>
</template>

<script lang="ts">
import Filter from '../../components/filterTable/index.vue';
import { defineComponent, queryTableList } from '@/common/export/table';
import { TypeAndTime } from '@/views/report/interface';
import { handleInitTypeAndTime } from '@/views/report/setup';
import { Ermcp3FinanceReport, FinanceReportReq } from '@/services/go/ermcp/report/interface';
import { qryFinanceReport } from '@/services/go/ermcp/report';
import { ComposeTableDetailParam, handleComposeTable_detail } from '@/common/setup/table/compose';
import Description from '@/common/components/description/index.vue';
import { TabList } from '@/common/components/description/interface';
import { queryResultLoadingAndInfo } from '@/common/methods/request/resultInfo';
import { ref, watchEffect } from 'vue';
import { EnumRouterName } from '@/common/constants/enumRouterName';

export default defineComponent({
    name: 'finance-report',
    components: {
        Filter,
        Description,
    },
    setup() {
        let cycletime = '';
        // 表格列表数据
        const { loading, tableList, queryTable } = queryTableList<Ermcp3FinanceReport>();
        // 获取列表数据
        const queryTableAction = () => {
            const { getInitTime, getInitType } = handleInitTypeAndTime();
            cycletime = getInitTime();
            const param: FinanceReportReq = {
                cycletype: getInitType(),
                cycletime,
                querytype: 1,
            };
            // 获取列表数据
            queryTable(qryFinanceReport, param);
        };
        const param: ComposeTableDetailParam = {
            queryFn: queryTableAction, // 查询表格数据
            tableName: 'table_pcweb_finance_report', // 表头key
            tableFilterKey: [], // 表格过滤字段
            menuType: EnumRouterName.finance_report_finance, // 当前tab页对应的code
        };
        const {
            visible,
            closeDrawer, // 控制 drawer 组件是否显示
            columns,
            updateColumn, //  表头数据
            columnsDetail,
            registerColumnDetail,
            detailTableList, // 明细表头数据
            expandedRowKeys,
            selectedRow,
            Rowclick, // 表格事件
            tabList,
        } = handleComposeTable_detail<Ermcp3FinanceReport>(param);
        const chaceSearchValue = ref<TypeAndTime>();
        // 切换明细
        function changeTab(index: number, current: TabList) {
            const { code, lable } = current;
            const data = selectedRow.value as Ermcp3FinanceReport;
            const { cycletype, currencyid } = data;
            const param: FinanceReportReq = {
                querytype: 2,
                cycletype,
                cycletime,
                currencyid,
                sumfields: '2',
                userid: chaceSearchValue.value?.userid,
            };
            if (code === 'finance_report_finance_category_breakdown') {
                // 品类明细
                // 注册表头
                registerColumnDetail('table_pcweb_financial_statement_category_breakdown', []);
                param.sumfields = '1,2';
            } else if (code === 'finance_report_finance_brand_details') {
                // 品牌明细
                // 注册表头
                registerColumnDetail('table_pcweb_financial_statement_brand_details', []);
                param.sumfields = '1,2,3';
            } else {
                console.error(`${lable}没有配置对应的code: ${code},`);
                return;
            }
            // 查询明细数据
            queryResultLoadingAndInfo(qryFinanceReport, loading, param).then((res) => {
                detailTableList.value = res;
            });
        }
        watchEffect(() => {
            if (visible.value) {
                if (tabList.value.length) {
                    changeTab(0, tabList.value[0]);
                }
            }
        });
        function search(value: TypeAndTime) {
            chaceSearchValue.value = value;
            cycletime = value.cycletime;
            const obj = Object.assign(value, { querytype: 1 });
            queryTable(qryFinanceReport, obj);
        }

        return { loading, tableList, visible, closeDrawer, columns, updateColumn, search, columnsDetail, detailTableList, expandedRowKeys, selectedRow, Rowclick, tabList, changeTab };
    },
});
</script>

<style lang="less">
</style>;
